import Flutter
import UIKit
import Foundation
import Cloudinary


public class SwiftCloudnaryFlutterPlugin: NSObject, FlutterPlugin {

    let channel: FlutterMethodChannel
    var result: FlutterResult!
    var fileData: NSMutableData = NSMutableData()
    var dataTask: URLSessionDataTask?
    var expectedContentLength = 0
    var progress: Float = 0.0
    var timer = Timer()
    
    init(channel: FlutterMethodChannel) {
        self.channel = channel
    }

//    let config =
    let cloudinary = CLDCloudinary(configuration: CLDConfiguration(cloudName: "CLOUD_NAME", secure: true))
    
  public static func register(with registrar: FlutterPluginRegistrar) {
    let channel = FlutterMethodChannel(name: "cloudnary_flutter", binaryMessenger: registrar.messenger())
      let instance = SwiftCloudnaryFlutterPlugin(channel: channel)
//      instance.prepareForInterfaceBuilder()
    registrar.addMethodCallDelegate(instance, channel: channel)
//      registrar.a

  }

  public func handle(_ call: FlutterMethodCall, result: @escaping FlutterResult) {
      if call.method == "uploadToCloudnary"{

          let tempData = call.arguments as? [String: AnyObject]
          let cloudName =  tempData?["cloudName"] as? String ?? ""
          let path =  tempData?["path"] as? String ?? ""
          let api =  tempData?["api"] as? String ?? ""
          let publicId =  tempData?["publicId"] as? String ?? ""
          let notificationUrl =  tempData?["notificationUrl"] as? String ?? ""
        
          
          let data = try? Data(contentsOf: URL(fileURLWithPath: path))
          
          let config = CLDConfiguration(cloudName: cloudName, secure: true)
          let cloudinary = CLDCloudinary(configuration: config)
          
          let params = CLDUploadRequestParams()
              .setPublicId(publicId)
//            .setBackgroundRemoval("cloudinary_ai")
            .setNotificationUrl(notificationUrl)
          
          let request = cloudinary.createUploader().signedUpload(
            data: data!, params: params)
          
      }
      
      if #available(iOS 10.0, *) {
          Timer.scheduledTimer(withTimeInterval: 1, repeats: true) { timer in
              self.progress = self.progress + 1
              
//              _channel.invokeMethod<String>('uploadToCloudnary', {
//                    'cloudName': cloudName,
//                    'api': api,
//                    'apiSecret': apiSecret,
//                    'publicId': publicId,
//                    'notificationUrl': notificationUrl,
//                    'path': path,
//                  }

              self.channel.invokeMethod("uploadToCloudnary", arguments: ["progress": Int(self.progress)])
          }
      } else {
          // Fallback on earlier versions
      }

      
    
//      result(FlutterError(code: "assertion_error", message: "imageId is required.", details: nil))

//      tempLoader.animate(withDuration: 30, delay: 1, options: .curveEaseIn, animations: {}, completion: {_ in
//          result("iOS " + UIDevice.current.systemVersion)
//      })
     
      
    
//      if let myViewController = Bundle.main.loadNibNamed("ImageUploadViewController", owner: nil, options: nil)?.first as? ImageUploadViewController {
//          self.navigationController?.pushViewController(myViewController, animated: true)
//        }
//      
  }
}
