import 'package:flutter/services.dart';
import 'package:flutter_test/flutter_test.dart';
import 'package:cloudnary_flutter/cloudnary_flutter.dart';

void main() {
  const MethodChannel channel = MethodChannel('cloudnary_flutter');

  TestWidgetsFlutterBinding.ensureInitialized();

  setUp(() {
    channel.setMockMethodCallHandler((MethodCall methodCall) async {
      return '42';
    });
  });

  tearDown(() {
    channel.setMockMethodCallHandler(null);
  });

  test('getPlatformVersion', () async {
    expect(await CloudnaryFlutter.uploadToCloudnary("cloudName", "api", "apiSecret", "publicId", "notificationUrl", "path"), '42');
  });
}
